using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Globalization;
using System.Threading;

namespace Resistance
{
	/// <summary>
	/// Summary description for FormMain.
	/// </summary>
	public class FormMain : System.Windows.Forms.Form
	{
		CultureInfo cultureInfo;
		Resistor r;

		int a = 2;
		int b = 4;

		#region DesignerFields
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox editResistance;
		private System.Windows.Forms.TextBox editVoltage;
		private System.Windows.Forms.Label lblVoltage;
		private System.Windows.Forms.TextBox editCurrent;
		private System.Windows.Forms.Label lblCurrent;
		private System.Windows.Forms.Label lblMaxPower;
		private System.Windows.Forms.TextBox editMaxPower;
		private System.Windows.Forms.RadioButton radioBtnOverload;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.RadioButton radioBtnVoltage;
		private System.Windows.Forms.RadioButton radioBtnCurrent;
		private System.Windows.Forms.Button btnClose;
		private System.Windows.Forms.Label lblPower;
		private System.Windows.Forms.TextBox editPower;
		private System.ComponentModel.Container components = null;
		#endregion

		public FormMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			cultureInfo = Thread.CurrentThread.CurrentCulture;
			r = new Resistor();
			GetData();
		}

		private void GetData()
		{
			if (r.Source == SourceType.ConstantVoltage)
			{
				editVoltage.Enabled = true;
				editCurrent.Enabled = false;
				radioBtnVoltage.Checked = true;
			}
			else
			{
				editVoltage.Enabled = false;
				editCurrent.Enabled = true;
				radioBtnCurrent.Checked = true;
			}

			editResistance.Text = r.Resistance.ToString("0.00", cultureInfo);
			editVoltage.Text = r.Voltage.ToString("0.00", cultureInfo);
			editCurrent.Text = r.Current.ToString("0.00", cultureInfo);
			editPower.Text = r.Power.ToString("0.00", cultureInfo);
			editMaxPower.Text = r.MaxPower.ToString("0.00", cultureInfo);
			radioBtnOverload.Checked = r.Overload;
		}

		private bool ValidateDouble(string text)
		{
			double result;
			return Double.TryParse(text, NumberStyles.Float, Thread.CurrentThread.CurrentCulture, out result);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.editResistance = new System.Windows.Forms.TextBox();
			this.editVoltage = new System.Windows.Forms.TextBox();
			this.lblVoltage = new System.Windows.Forms.Label();
			this.editCurrent = new System.Windows.Forms.TextBox();
			this.lblCurrent = new System.Windows.Forms.Label();
			this.lblMaxPower = new System.Windows.Forms.Label();
			this.editMaxPower = new System.Windows.Forms.TextBox();
			this.radioBtnOverload = new System.Windows.Forms.RadioButton();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.radioBtnVoltage = new System.Windows.Forms.RadioButton();
			this.radioBtnCurrent = new System.Windows.Forms.RadioButton();
			this.btnClose = new System.Windows.Forms.Button();
			this.lblPower = new System.Windows.Forms.Label();
			this.editPower = new System.Windows.Forms.TextBox();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 19);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(104, 18);
			this.label1.TabIndex = 0;
			this.label1.Text = "Resistance:";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// editResistance
			// 
			this.editResistance.Location = new System.Drawing.Point(128, 17);
			this.editResistance.Name = "editResistance";
			this.editResistance.Size = new System.Drawing.Size(112, 20);
			this.editResistance.TabIndex = 1;
			this.editResistance.Text = "";
			this.editResistance.Validating += new System.ComponentModel.CancelEventHandler(this.editResistance_Validating);
			this.editResistance.Validated += new System.EventHandler(this.editResistance_Validated);
			// 
			// editVoltage
			// 
			this.editVoltage.Location = new System.Drawing.Point(128, 56);
			this.editVoltage.Name = "editVoltage";
			this.editVoltage.Size = new System.Drawing.Size(112, 20);
			this.editVoltage.TabIndex = 1;
			this.editVoltage.Text = "";
			this.editVoltage.Validating += new System.ComponentModel.CancelEventHandler(this.editVoltage_Validating);
			this.editVoltage.Validated += new System.EventHandler(this.editVoltage_Validated);
			// 
			// lblVoltage
			// 
			this.lblVoltage.Location = new System.Drawing.Point(8, 58);
			this.lblVoltage.Name = "lblVoltage";
			this.lblVoltage.Size = new System.Drawing.Size(104, 18);
			this.lblVoltage.TabIndex = 0;
			this.lblVoltage.Text = "Voltage:";
			this.lblVoltage.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// editCurrent
			// 
			this.editCurrent.Location = new System.Drawing.Point(128, 92);
			this.editCurrent.Name = "editCurrent";
			this.editCurrent.Size = new System.Drawing.Size(112, 20);
			this.editCurrent.TabIndex = 1;
			this.editCurrent.Text = "";
			this.editCurrent.Validating += new System.ComponentModel.CancelEventHandler(this.editCurrent_Validating);
			this.editCurrent.Validated += new System.EventHandler(this.editCurrent_Validated);
			// 
			// lblCurrent
			// 
			this.lblCurrent.Location = new System.Drawing.Point(8, 94);
			this.lblCurrent.Name = "lblCurrent";
			this.lblCurrent.Size = new System.Drawing.Size(104, 18);
			this.lblCurrent.TabIndex = 0;
			this.lblCurrent.Text = "Current:";
			this.lblCurrent.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblMaxPower
			// 
			this.lblMaxPower.Location = new System.Drawing.Point(8, 134);
			this.lblMaxPower.Name = "lblMaxPower";
			this.lblMaxPower.Size = new System.Drawing.Size(104, 18);
			this.lblMaxPower.TabIndex = 0;
			this.lblMaxPower.Text = "Maximum power:";
			this.lblMaxPower.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// editMaxPower
			// 
			this.editMaxPower.Location = new System.Drawing.Point(128, 132);
			this.editMaxPower.Name = "editMaxPower";
			this.editMaxPower.Size = new System.Drawing.Size(112, 20);
			this.editMaxPower.TabIndex = 1;
			this.editMaxPower.Text = "";
			this.editMaxPower.Validating += new System.ComponentModel.CancelEventHandler(this.editMaxPower_Validating);
			this.editMaxPower.Validated += new System.EventHandler(this.editMaxPower_Validated);
			// 
			// radioBtnOverload
			// 
			this.radioBtnOverload.Enabled = false;
			this.radioBtnOverload.ForeColor = System.Drawing.SystemColors.ControlText;
			this.radioBtnOverload.Location = new System.Drawing.Point(264, 133);
			this.radioBtnOverload.Name = "radioBtnOverload";
			this.radioBtnOverload.Size = new System.Drawing.Size(88, 20);
			this.radioBtnOverload.TabIndex = 2;
			this.radioBtnOverload.Text = "Overload";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.radioBtnVoltage);
			this.groupBox1.Controls.Add(this.radioBtnCurrent);
			this.groupBox1.Location = new System.Drawing.Point(8, 216);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(232, 84);
			this.groupBox1.TabIndex = 3;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Source";
			// 
			// radioBtnVoltage
			// 
			this.radioBtnVoltage.Location = new System.Drawing.Point(12, 20);
			this.radioBtnVoltage.Name = "radioBtnVoltage";
			this.radioBtnVoltage.Size = new System.Drawing.Size(180, 24);
			this.radioBtnVoltage.TabIndex = 0;
			this.radioBtnVoltage.Text = "Constant voltage";
			this.radioBtnVoltage.CheckedChanged += new System.EventHandler(this.radioBtnVoltage_CheckedChanged);
			// 
			// radioBtnCurrent
			// 
			this.radioBtnCurrent.Location = new System.Drawing.Point(12, 52);
			this.radioBtnCurrent.Name = "radioBtnCurrent";
			this.radioBtnCurrent.Size = new System.Drawing.Size(180, 24);
			this.radioBtnCurrent.TabIndex = 0;
			this.radioBtnCurrent.Text = "Constant current";
			// 
			// btnClose
			// 
			this.btnClose.Location = new System.Drawing.Point(264, 276);
			this.btnClose.Name = "btnClose";
			this.btnClose.Size = new System.Drawing.Size(88, 24);
			this.btnClose.TabIndex = 4;
			this.btnClose.Text = "Close";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// lblPower
			// 
			this.lblPower.Location = new System.Drawing.Point(8, 168);
			this.lblPower.Name = "lblPower";
			this.lblPower.Size = new System.Drawing.Size(104, 18);
			this.lblPower.TabIndex = 0;
			this.lblPower.Text = "Power:";
			this.lblPower.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// editPower
			// 
			this.editPower.Location = new System.Drawing.Point(128, 168);
			this.editPower.Name = "editPower";
			this.editPower.ReadOnly = true;
			this.editPower.Size = new System.Drawing.Size(112, 20);
			this.editPower.TabIndex = 1;
			this.editPower.Text = "";
			// 
			// FormMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(360, 311);
			this.Controls.Add(this.btnClose);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.radioBtnOverload);
			this.Controls.Add(this.editResistance);
			this.Controls.Add(this.editVoltage);
			this.Controls.Add(this.editCurrent);
			this.Controls.Add(this.editMaxPower);
			this.Controls.Add(this.editPower);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.lblVoltage);
			this.Controls.Add(this.lblCurrent);
			this.Controls.Add(this.lblMaxPower);
			this.Controls.Add(this.lblPower);
			this.ForeColor = System.Drawing.SystemColors.ControlText;
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "FormMain";
			this.Text = "Resistance";
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FormMain());
		}

		private void editResistance_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (!ValidateDouble(editResistance.Text))
			{
				MessageBox.Show(this, "Please enter a number!", "Input error!");
				e.Cancel = true;
			}
		}

		private void editResistance_Validated(object sender, System.EventArgs e)
		{
			r.Resistance = Double.Parse(editResistance.Text);
			GetData();
		}

		private void editVoltage_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (!ValidateDouble(editVoltage.Text))
			{
				MessageBox.Show(this, "Please enter a number!", "Input error!");
				e.Cancel = true;
			}		
		}

		private void editVoltage_Validated(object sender, System.EventArgs e)
		{
			r.Voltage = Double.Parse(editVoltage.Text);
			GetData();		
		}

		private void editCurrent_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (!ValidateDouble(editCurrent.Text))
			{
				MessageBox.Show(this, "Please enter a number!", "Input error!");
				e.Cancel = true;
			}	
		}

		private void editCurrent_Validated(object sender, System.EventArgs e)
		{
			r.Current = Double.Parse(editCurrent.Text);
			GetData();	
		}

		private void editMaxPower_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (!ValidateDouble(editCurrent.Text))
			{
				MessageBox.Show(this, "Please enter a number!", "Input error!");
				e.Cancel = true;
			}		
		}

		private void editMaxPower_Validated(object sender, System.EventArgs e)
		{
			r.MaxPower = Double.Parse(editMaxPower.Text);
			GetData();			
		}

		private void radioBtnVoltage_CheckedChanged(object sender, System.EventArgs e)
		{
			if (radioBtnVoltage.Checked)
				r.Source = SourceType.ConstantVoltage;
			else
				r.Source = SourceType.ConstantCurrent;
			GetData();
		}

		private void btnClose_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}
	}
}
